package QA.mng;

import java.util.Properties;
import java.util.ArrayList;
import java.util.Enumeration;
import java.io.FileInputStream;
import java.io.File;
import com.wm.app.b2b.server.ServerAPI;

public class PropManager {
  private static volatile Properties propFlow = null;
  private static volatile Properties propJava = null;
  private static volatile Properties propTrg = null;
  private static volatile Properties propPkg = null;
  private static volatile Properties propDoc = null;
  private static volatile Properties propAdp = null;
  private static volatile Properties propExt = null;

  private static volatile String[] javaContentToCheck = null;
  private static volatile String[] flowContentToCheck = null;
  private static volatile String[] trgConfigToCheck = null;
  private static volatile String[] serviceConfigToCheck = null;
  private static volatile String[] pkgConfigToCheck = null;
  private static volatile String[] documentToCheck = null;
  private static volatile String[] adapterServiceToCheck = null;
  private static volatile String[] extendedSettingsToCheck = null;

  public static void reset() {
	  propFlow = null;
	  propJava = null;
	  propTrg = null;
	  propPkg = null;
	  propDoc = null;
	  propAdp = null;
	  propExt = null;
    //System.out.println("reset");
  }

  public static String[] getPackageConfigToCheck() {
    //propJava = null;
    //System.out.println(" getPackageConfigToCheck " + new java.util.Date() + " propPkg null" + (propTrg == null));
  	if( propPkg == null || pkgConfigToCheck == null) {
  		pkgConfigToCheck = null;

  		ArrayList al = new ArrayList();
  		Properties prop = getProperties(PACKAGE_PROPERTIES);
  		Enumeration enum = prop.propertyNames();
  		while(enum.hasMoreElements() ) {
  			String key = (String) enum.nextElement();
  			String enable = prop.getProperty(key);
  			if(!"none".equalsIgnoreCase(enable)) al.add(key);
  		}
  		int iSize = al.size();
      	if( iSize > 0 ) {
      		String[] javaArray = new String[iSize];
  			pkgConfigToCheck = (String[]) al.toArray(javaArray);
  		}
  	}
  	return pkgConfigToCheck;
  }


  public static String[] getServiceConfigToCheck(String type) {
    Properties props = null;
    if( type.equals(FLOW_SERVICE_PROPERTIES) ) props = propFlow;
  	if( type.equals(JAVA_SERVICE_PROPERTIES) ) props = propJava;
  	if( type.equals(ADAPTER_SERVICE_PROPERTIES) ) props = propAdp;

    //System.out.println(" getServiceConfigToCheck " + new java.util.Date() + " props null" + (props == null));
  	if( props == null || serviceConfigToCheck == null ) {
  		serviceConfigToCheck = null;

  		ArrayList al = new ArrayList();
  		Properties prop = getProperties(type);
  		Enumeration enum = prop.propertyNames();
  		while(enum.hasMoreElements() ) {
  			String key = (String) enum.nextElement();
  			String val = key.substring(key.indexOf("-") + 1, key.length());
  			if(key.startsWith("config-")) {
  				String enable = prop.getProperty(key);
  				if(!"none".equalsIgnoreCase(enable)) al.add(val);
  			}
  		}
  		int iSize = al.size();
      	if( iSize > 0 ) {
      		String[] javaArray = new String[iSize];
  			serviceConfigToCheck = (String[]) al.toArray(javaArray);
  		}
  	}
  	return serviceConfigToCheck;
  }

  public static String[] getJavaContentToCheck() {
    //propJava = null;
    //System.out.println(" getJavaContentToCheck " + new java.util.Date() + " propJava null" + (propJava == null));
  	if( propJava == null || javaContentToCheck == null ) {
  		javaContentToCheck = null;

  		ArrayList al = new ArrayList();
  		Properties prop = getProperties(JAVA_SERVICE_PROPERTIES);
  		Enumeration enum = prop.propertyNames();
  		while(enum.hasMoreElements() ) {
  			String key = (String) enum.nextElement();
  			String val = key.substring(key.indexOf("-") + 1, key.length());
  			if(key.startsWith("content-")) {
  				String enable = prop.getProperty(key);
  				if("true".equalsIgnoreCase(enable)) al.add(val);
  			}
  		}
  		int iSize = al.size();
      	if( iSize > 0 ) {
      		String[] javaArray = new String[iSize];
  			javaContentToCheck = (String[]) al.toArray(javaArray);
  		}
  	}
  	return javaContentToCheck;
  }

  public static String[] getFlowContentToCheck() {
    //System.out.println(" getFlowContentToCheck " + new java.util.Date() + " propFlow null" + (propFlow == null));
  	if( propFlow == null || flowContentToCheck == null ) {
  		flowContentToCheck = null;

  		ArrayList al = new ArrayList();
  		Properties prop = getProperties(FLOW_SERVICE_PROPERTIES);
  		Enumeration enum = prop.propertyNames();
  		while(enum.hasMoreElements() ) {
  			String key = (String) enum.nextElement();
  			//System.out.println(" key :  " + key);
  			String val = key.substring(key.indexOf("-") + 1, key.length());
  			if(key.startsWith("content-")) {
  				String enable = prop.getProperty(key);
  				//System.out.println(" enable :  " + enable);
  				if("true".equalsIgnoreCase(enable)) al.add(val);
  			}
  		}
  		int iSize = al.size();
      	if( iSize > 0 ) {
      		String[] flowArray = new String[iSize];
  			flowContentToCheck = (String[]) al.toArray(flowArray);
  		}
  	}
  	return flowContentToCheck;
  }


  public static String[] getDocumentToCheck() {
  	if( propDoc == null || documentToCheck == null ) {
  		documentToCheck = null;

  		ArrayList al = new ArrayList();
  		Properties prop = getProperties(DOCUCUMENT_PROPERTIES);
  		Enumeration enum = prop.propertyNames();
  		while(enum.hasMoreElements() ) {
  			String key = (String) enum.nextElement();
  			//System.out.println(" key :  " + key);
  			String val = key.substring(key.indexOf("-") + 1, key.length());
  			if(key.startsWith("content-")) {
  				String enable = prop.getProperty(key);
  				//System.out.println(" enable :  " + enable);
  				if("true".equalsIgnoreCase(enable)) al.add(val);
  			}
  		}
  		int iSize = al.size();
      	if( iSize > 0 ) {
      		String[] docArray = new String[iSize];
  			documentToCheck = (String[]) al.toArray(docArray);
  		}
  	}
  	return documentToCheck;
  }

  public static String[] getTriggerConfigToCheck() {
    //System.out.println(" getTriggerConfigToCheck " + new java.util.Date() + " propTrg null" + (propTrg == null));
  	if( propTrg == null || trgConfigToCheck == null ) {
  		trgConfigToCheck = null;

  		ArrayList al = new ArrayList();
  		Properties prop = getProperties(TRIGGERS_PROPERTIES);
  		Enumeration enum = prop.propertyNames();
  		while(enum.hasMoreElements() ) {
  			String key = (String) enum.nextElement();
  			//System.out.println(" key :  " + key);
  		  String enable = prop.getProperty(key);
  				//System.out.println(" enable :  " + enable);
  			if(!"none".equalsIgnoreCase(enable)) al.add(key);
  		}
  		int iSize = al.size();
      	if( iSize > 0 ) {
      		String[] trgArray = new String[iSize];
  			trgConfigToCheck = (String[]) al.toArray(trgArray);
  		}
  	}
  	return trgConfigToCheck;
  }


  public static String[] getExtendedSettingsToCheck() {
    //System.out.println(" getExtendedSettingsToCheck " + new java.util.Date() + " propTrg null" + (propTrg == null));
  	if( propExt == null || extendedSettingsToCheck == null ) {
  		extendedSettingsToCheck = null;

  		ArrayList al = new ArrayList();
  		Properties prop = getProperties(EXTENDED_SETTINGS_PROPERTIES);
  		Enumeration enum = prop.propertyNames();
  		while(enum.hasMoreElements() ) {
  			String key = (String) enum.nextElement();
  			//System.out.println(" key :  " + key);
  		  String enable = prop.getProperty(key);
  				//System.out.println(" enable :  " + enable);
  			if(!"none".equalsIgnoreCase(enable)) al.add(key);
  		}
  		int iSize = al.size();
      	if( iSize > 0 ) {
      		String[] extArray = new String[iSize];
  			extendedSettingsToCheck = (String[]) al.toArray(extArray);
  		}
  	}
  	return extendedSettingsToCheck;
  }

  public static Properties getProperties(String type) {
    try {
      Properties props = null;
	    if( type.equals(FLOW_SERVICE_PROPERTIES) ) props = propFlow;
  		if( type.equals(JAVA_SERVICE_PROPERTIES) ) props = propJava;
  		if( type.equals(TRIGGERS_PROPERTIES) ) props = propTrg;
  		if( type.equals(PACKAGE_PROPERTIES) ) props = propPkg;
  		if( type.equals(DOCUCUMENT_PROPERTIES) ) props = propDoc;
  		if( type.equals(ADAPTER_SERVICE_PROPERTIES) ) props = propAdp;
  		if( type.equals(EXTENDED_SETTINGS_PROPERTIES) ) props = propExt;
  		if(props == null) {
  			props = new Properties();
   			props.load(new FileInputStream(getFileConfig(type)));
  			if( type.equals(FLOW_SERVICE_PROPERTIES) ) propFlow = props;
  			if( type.equals(JAVA_SERVICE_PROPERTIES) ) propJava = props;
  			if( type.equals(TRIGGERS_PROPERTIES) ) propTrg = props;
  			if( type.equals(PACKAGE_PROPERTIES) ) propPkg = props;
  			if( type.equals(DOCUCUMENT_PROPERTIES) ) propDoc = props;
  			if( type.equals(ADAPTER_SERVICE_PROPERTIES) ) propAdp = props;
  			if( type.equals(EXTENDED_SETTINGS_PROPERTIES) ) propExt = props;
  		}
    	return props;
	  } catch (Exception ex) {
		  return null;
	  }
  }

  public static boolean isNumeric(String value) {
    try {
      Integer.parseInt(value);
      return true;
    } catch (Exception ex) {
      return false;
    }
  }

  public static String getProperty(String key, String type) {
    try {
  	  return getProperties(type).getProperty(key);
  	} catch (Exception ex) {
		  return "";
	  }
  }

  //Construction d'un objet File, dans le rpertoire config d'un package
  public static File getFileConfig(String name) throws java.io.IOException {
	  File dirConfig = ServerAPI.getPackageConfigDir("QA");
    String fullDirName = dirConfig.getCanonicalPath();

	  return new File(fullDirName, name);
  }


  public static final String PACKAGE_PROPERTIES = "package.conf";
  public static final String JAVA_SERVICE_PROPERTIES = "javaservice.conf";
  public static final String FLOW_SERVICE_PROPERTIES = "flowservice.conf";
  public static final String DOCUCUMENT_PROPERTIES = "documents.conf";
  public static final String TRIGGERS_PROPERTIES = "trigger.conf";
  public static final String ADAPTER_SERVICE_PROPERTIES = "adpservice.conf";
  public static final String EXTENDED_SETTINGS_PROPERTIES = "settings.conf";
}