package QA;

// -----( IS Java Code Template v1.2
// -----( CREATED: 2006-09-08 10:01:05 CEST
// -----( ON-HOST: dmd01

import com.wm.data.*;
import com.wm.util.Values;
import com.wm.app.b2b.server.Service;
import com.wm.app.b2b.server.ServiceException;
// --- <<IS-START-IMPORTS>> ---
import java.util.Iterator;
import java.util.HashMap;
import java.util.ArrayList;
import java.util.Set;
import com.wm.lang.ns.NSPackage;
import java.util.Enumeration;
import com.wm.lang.ns.NSNode;
import com.wm.lang.ns.NSTrigger;
import com.wm.lang.ns.NSName;
import java.util.Vector;
import com.wm.app.b2b.server.FlowSvcImpl;
import com.wm.app.b2b.ws.ns.NSFacade;
import com.wm.app.b2b.server.ns.Namespace;
import com.wm.lang.flow.FlowElement;
import com.wm.app.b2b.server.InvokeState;
import java.io.File;
import com.wm.app.b2b.server.ServerAPI;
import de.fub.bytecode.classfile.JavaClass;
import de.fub.bytecode.classfile.ClassParser;
import de.fub.bytecode.classfile.Method;
import de.fub.bytecode.classfile.Utility;
import java.util.Properties;
import java.util.Enumeration;
import com.wm.app.b2b.server.BaseService;
import QA.mng.PropManager;
import com.wm.lang.ns.NSRecord;
import com.wm.lang.ns.NSSignature;
import com.wm.app.b2b.util.ServerIf;
import com.wm.lang.ns.EventDescription;
import com.wm.lang.ns.NSService;
import com.wm.lang.ns.NSField;
import com.wm.lang.ns.NSPackage;
import java.io.FileFilter;
import com.wm.lang.flow.FlowMap;
import com.wm.lang.flow.FlowMapCopy;
// --- <<IS-END-IMPORTS>> ---

public final class QAAnalyze

{
	// ---( internal utility methods )---

	final static QAAnalyze _instance = new QAAnalyze();

	static QAAnalyze _newInstance() { return new QAAnalyze(); }

	static QAAnalyze _cast(Object o) { return (QAAnalyze)o; }

	// ---( server methods )---




	public static final void AnalyzeDeadCode (IData pipeline)
        throws ServiceException
	{
		// --- <<IS-START(AnalyzeDeadCode)>> ---
		// @subtype unknown
		// @sigtype java 3.5
		// [i] field:0:optional packageName
		// [o] record:1:required DeadCode
		// [o] - field:0:required package
		// [o] - field:1:required methods
		try {
		    IDataCursor cursor 		= pipeline.getCursor();
		    String	packageName	= IDataUtil.getString(cursor,"packageName");
		    NSPackage[] pkg         	= com.wm.app.b2b.server.ns.Namespace.current().getAllPackages();
		
		    HashMap hmClasses = new HashMap();
		
		    boolean deadCode = 
			QA.mng.PropManager.getProperties(PropManager.JAVA_SERVICE_PROPERTIES).
			getProperty("check-deadcode","false").equalsIgnoreCase("true");
		
		    for(int i=0; (deadCode && i<pkg.length); i++) {
			String pkgName = pkg[i].getName();
		
		    	if(!pkgName.startsWith("SAP") && !pkgName.startsWith("Wm") && !pkgName.startsWith("QA") && (packageName == null || pkgName.equals(packageName))) {
		     	    Vector list = com.wm.app.b2b.server.ns.Namespace.current().getNodes(new com.wm.app.b2b.server.Package(pkgName));
		      	    Enumeration enum = list.elements();
		      	    while(enum.hasMoreElements()) {
		            	NSNode node = (NSNode)enum.nextElement();
				String nodeName = node.getNSName().getValue();
		   		String typeName = node.getNodeTypeObj().getValue();
		
				if(typeName.equals(ServerIf.KEY_SERVICE_NAME)) {
		
		                    IData param = IDataFactory.create();
		                    IDataCursor curParam = param.getCursor();
				    curParam.insertAfter("name", nodeName);
		                    IData nodeService = Service.doInvoke("wm.server.ns","getNode",param);
		
				    IDataCursor curNodeService = nodeService.getCursor();
				    String lockStatus = IDataUtil.getString(curNodeService,NSNode.KEY_LOCK_STATUS);
				    Object nodeType = IDataUtil.get(curNodeService,"node");
		
				    if(nodeType instanceof com.wm.app.b2b.server.JavaService && !nodeName.startsWith("QA.QA")) {
		    			int pkgSep = nodeName.indexOf(":");
		    			String javaPackage = nodeName.substring(0,pkgSep);
					ClassPackage cp = (ClassPackage) hmClasses.get(pkgName);
					if( cp == null ) {
					    cp = new ClassPackage(pkgName);
					    hmClasses.put(pkgName, cp);
					}
					cp.setClass(javaPackage);			
				    }
				    curNodeService.destroy();
				    curParam.destroy();
				}
			    }
			}
		    }
		
		    ArrayList alErrors = new ArrayList();
		
		    if( hmClasses.size() > 0 ) {
			Iterator itPack = hmClasses.values().iterator();
			while( itPack.hasNext() ) {
			    ClassPackage cpClasses = (ClassPackage) itPack.next();
			    HashMap hmClass = new HashMap();
			    HashMap hmMethKO  = new HashMap();
		
			    String[] classes = cpClasses.getClassList();
			    String pkgName = cpClasses.getPackageName();
		
			    // R\u00e9cup\u00e9ration de toutes les m\u00e9thodes de toutes les classes d'un package
			    for(int iClass=0; iClass<classes.length; iClass++) {
				String mainCLass = getFullClassName(pkgName, classes[iClass]);
				
		    		if( (new File(mainCLass)).exists()) {
				    JavaClass java_class = new ClassParser(mainCLass).parse();
				    Method[] meth = java_class.getMethods();
				    for(int i=0;i<meth.length;i++) {
				    	String clMth = fillClassMethods(classes[iClass], meth[i].getName(), meth[i].getCode().toString(), hmClass); 
		
				    	// Les java services sont consid\u00e9r\u00e9s comme \u00e9tant utiles : signature Lcom/wm/data/IData;
				    	if( !meth[i].getSignature().equals("(Lcom/wm/data/IData;)V") && clMth != null) {
				    	    hmMethKO.put(clMth, clMth);
				    	}
				    }
		
				    String[] extendedClassList = getFullIncludedClassName(mainCLass);
				    for(int i=0; i<extendedClassList.length; i++) {
				    	JavaClass javaExt = new ClassParser(extendedClassList[i]).parse();
				    	hmMethKO.put(javaExt.getClassName(), javaExt.getClassName());
				    }
			        }
			    }
		
		            // Analyse de l'utilisation des m\u00e9thodes par d'autres m\u00e9thodes
			    Set keyList = hmClass.keySet();
			    String[] sKeys = new String[keyList.size()];
			    sKeys = (String[]) keyList.toArray(sKeys);
			    for(int iKey=0; iKey<sKeys.length; iKey++ ) {
				String content = (String) hmClass.get(sKeys[iKey]);
				Iterator itKeyListKo = hmMethKO.values().iterator();
				while( itKeyListKo.hasNext() ){
				    String meth = (String) itKeyListKo.next();
				    if( content.indexOf(meth) != -1)  {
					itKeyListKo.remove();
				    }
				}
			    }
		
			    Iterator itKeyListKo = hmMethKO.values().iterator();
			    ClassPackage cpErrors = new ClassPackage(pkgName);
			    if( itKeyListKo.hasNext() ) alErrors.add(cpErrors);
		
			    while( itKeyListKo.hasNext() ){	
				cpErrors.setClass((String) itKeyListKo.next());
			    }
			}
		
		    }
		
		    if( alErrors.size() > 0 ) {
			IData[] errors = new IData[alErrors.size()];
			for(int i=0; i<alErrors.size(); i++ ) {
			    ClassPackage cpErrors = (ClassPackage) alErrors.get(i);
			    errors[i] 		= IDataFactory.create();
			    IDataCursor cursorCP= errors[i].getCursor();
			    cursorCP.insertAfter("package", cpErrors.getPackageName());
			    cursorCP.insertAfter("methods", cpErrors.getClassList());
			    cursorCP.destroy();
			}
			cursor.insertAfter("DeadCode", errors);
		    }
		    cursor.destroy();
		} catch(Exception ex) {
		    throw new ServiceException("[Erreur dans AnalyzeDeadCode] : " + ex.toString());
		}
		// --- <<IS-END>> ---

                
	}



	public static final void AnalyzeDocuments (IData pipeline)
        throws ServiceException
	{
		// --- <<IS-START(AnalyzeDocuments)>> ---
		// @subtype unknown
		// @sigtype java 3.5
		// [i] field:0:required name
		// [i] field:0:required pkg
		// [o] record:1:required DocumentError
		// [o] - field:0:required name
		// [o] - field:0:required pkg
		// [o] - field:1:optional error_type
		// [o] - field:0:optional brkRealName
		// [o] - field:0:optional brkNormalName
		try {
		    IDataCursor cursor 		= pipeline.getCursor();
		    String	isName   	= IDataUtil.getString(cursor,"name");
		    String	pkg		= IDataUtil.getString(cursor,"pkg");
		    IData[]     documentError	= IDataUtil.getIDataArray(cursor,"DocumentError");
		
		    ArrayList alErrors = new ArrayList();
		
		
		    IData param = IDataFactory.create();
		    IDataCursor curParam = param.getCursor();
		    curParam.insertAfter("name", isName);
		    curParam.destroy();
		
		    IData nodeService = Service.doInvoke("wm.server.ns","getNode",param);
		    IDataCursor curNodeService = nodeService.getCursor();
		    Object nodeType = IDataUtil.get(curNodeService,"node");
		    curNodeService.destroy();
		
		    String brkRealName = null;
		    String brkNormalName = null;
		
		    if( nodeType instanceof NSRecord) {
			NSRecord record = (NSRecord) nodeType;
			Values recordInfo = (Values) record.getValues().getValue(NSRecord.KEY_NSR_EVENT_DESCRIPTION);
			if( recordInfo != null ) {
			    String brokerEventTypeName = (String) recordInfo.getValue(EventDescription.KEY_ED_BROKER_EVENT_TYPE_NAME);
			    String isDocName = isName.substring(isName.lastIndexOf(":") + 1, isName.length());
			    String brkDocName = brokerEventTypeName.substring(brokerEventTypeName.lastIndexOf(":") + 1, 
			    	brokerEventTypeName.length());
		
			    String[] propConfig = QA.mng.PropManager.getDocumentToCheck();
			    if( propConfig != null ) {
				for(int iProp=0; iProp<propConfig.length; iProp++) {
			  	    String configToTest =  propConfig[iProp];
			  	    String curValue 	= (String) recordInfo.get(configToTest);
		
			  	    String confValue	= PropManager.getProperty("config-" + configToTest,PropManager.DOCUCUMENT_PROPERTIES);
			  	    if(!confValue.equals(curValue)) {
			  	    	alErrors.add("Probl\u00e8me de configuration : " + configToTest + "=" + curValue + " au lieu de " + confValue);
			  	    }
				}
			    }
		
			    if( !brkDocName.equals(isDocName) ) {
				brkRealName = brokerEventTypeName;
				brkNormalName = brokerEventTypeName.substring(0, brokerEventTypeName.lastIndexOf(":") + 1) + isDocName;
			    }
			}
		    }
		
		    int iErrors = alErrors.size();
		    if( iErrors > 0 || brkRealName != null) {
		    	String[] errors = new String[iErrors];
			IData[] docError = new IData[1];
			docError[0] = IDataFactory.create();
			IDataCursor curDocError = docError[0].getCursor();
		
			curDocError.insertAfter("name", isName);
			curDocError.insertAfter("pkg", pkg);
			if( iErrors > 0 ) curDocError.insertAfter("error_type", (String[]) alErrors.toArray(errors));
			if( brkRealName != null) {
			    curDocError.insertAfter("brkRealName", brkRealName);
			    curDocError.insertAfter("brkNormalName", brkNormalName);
			}
			curDocError.destroy();
		
			IDataUtil.remove(cursor, "DocumentError");
			if( documentError != null && documentError.length > 0 ) {
			    IData[] documentErrorNew = new IData[documentError.length + 1 ];
			    System.arraycopy(documentError, 0, documentErrorNew, 0,  documentError.length );
			    documentErrorNew[documentError.length] = docError[0];
			    cursor.insertAfter("DocumentError", documentErrorNew);		
			} else {
			    cursor.insertAfter("DocumentError", docError);
			}
		    }
		    cursor.destroy();
		} catch(Exception ex) {
		    throw new ServiceException("[Erreur dans AnalyzeDocument] : " + ex.toString());
		}
		// --- <<IS-END>> ---

                
	}



	public static final void AnalyzeExtendedSettings (IData pipeline)
        throws ServiceException
	{
		// --- <<IS-START(AnalyzeExtendedSettings)>> ---
		// @subtype unknown
		// @sigtype java 3.5
		// [o] field:1:required settings_errors
		try {
		    IData nodeService 		= Service.doInvoke("wm.server.query","getSettings",null);
		    IDataCursor curNodeService 	= nodeService.getCursor();
		    ArrayList alErrors 		= new ArrayList();
		
		    String[] propSettings	= QA.mng.PropManager.getExtendedSettingsToCheck();
		    for(int iProp=0; (propSettings != null && iProp<propSettings.length); iProp++) {
			String setting 		= propSettings[iProp];
			String valsetting	= QA.mng.PropManager.getProperties(
							QA.mng.PropManager.EXTENDED_SETTINGS_PROPERTIES).getProperty(setting);
			if( !"none".equalsIgnoreCase(valsetting) ) {
			    String curConfig = IDataUtil.getString(curNodeService, setting);
			    if( !valsetting.equalsIgnoreCase(curConfig) ) {
				alErrors.add("Probl\u00e8me de configuration : " + setting + "=" + curConfig + " au lieu de " + valsetting);
			    }
		        }
		    }
		    curNodeService.destroy();
		
		    int iErrors = alErrors.size();
		    if( iErrors > 0 ) {
		    	String[] errors 	= new String[iErrors];
		 	IDataCursor cursor	= pipeline.getCursor();
			cursor.insertAfter("settings_errors", alErrors.toArray(errors));
			cursor.destroy();
		    }
		} catch(Exception ex) {
		    throw new ServiceException("[Erreur dans AnalyzeExtendedSettings] : " + ex.toString());
		}
		// --- <<IS-END>> ---

                
	}



	public static final void AnalyzeFlowService (IData pipeline)
        throws ServiceException
	{
		// --- <<IS-START(AnalyzeFlowService)>> ---
		// @subtype unknown
		// @sigtype java 3.5
		// [i] field:0:required name
		// [i] field:0:required pkg
		// [o] record:1:required FlowError
		// [o] - field:0:required name
		// [o] - field:0:required pkg
		// [o] - record:1:required errors
		// [o] -- field:0:required object_name
		// [o] -- field:0:required object_type
		// [o] -- field:0:required error_type
		// [o] -- field:0:required error_path
		String	name = null;
		try {
		    IDataCursor cursor 		= pipeline.getCursor();
		    		name   		= IDataUtil.getString(cursor,"name");
		    String	pkg		= IDataUtil.getString(cursor,"pkg");
		    IData[]     flowError	= IDataUtil.getIDataArray(cursor,"FlowError");
		    IData[]     flowConfig	= IDataUtil.getIDataArray(cursor,"FlowConfig");
		
		    ArrayList alErrors = new ArrayList();
		    IData param = IDataFactory.create();
		    IDataCursor curParam = param.getCursor();
		    curParam.insertAfter("name", name);
		    curParam.insertAfter("flow", name);
		    curParam.destroy();
		
		    IData nodeService = Service.doInvoke("wm.server.ns","getNode",param);
		    IDataCursor curNodeService = nodeService.getCursor();
		    Object nodeType = IDataUtil.get(curNodeService,"node");
		    curNodeService.destroy();
		    if( nodeType == null ) {
			IData vparam = IDataFactory.create();
			IDataCursor curvParam = vparam.getCursor();
			curvParam.insertAfter("object_name", name);	
			curvParam.insertAfter("object_type", "FLOW SERVICE");	
			curvParam.insertAfter("error_type", "Le service ne peut pas etre analyse");	
			curvParam.insertAfter("error_path", "ROOT");		
			curvParam.destroy();
			alErrors.add(vparam);
		    } else {
		    	Values v = NSFacade.valuesEncodeFlowSvcImpl((FlowSvcImpl) nodeType);
		    	Vector vect = (Vector) ((Values) v.get(ServerIf.DM_KEY_FLOW)).get(ServerIf.KEY_NODES); //flow, nodes
		
		    	if( vect == null ) {
			    IData vparam = IDataFactory.create();
			    IDataCursor curvParam = vparam.getCursor();
			    curvParam.insertAfter("object_name", name);	
			    curvParam.insertAfter("object_type", "FLOW SERVICE");	
			    curvParam.insertAfter("error_type", "Le service n'a pas de contenu");	
			    curvParam.insertAfter("error_path", "ROOT");		
			    curvParam.destroy();
			    alErrors.add(vparam);
		    	} else {
		    	    for(int i=0; i<vect.size(); i++) {
			    	FlowElement flowelmt = (FlowElement)vect.get(i);
			    	analyzeFlowElement("/", (FlowElement) vect.get(i), alErrors);
			    }
		    	}   
		    }
		    
		    IData IDataFlowMapPath = Service.doInvoke("wm.server.ns.dependency","validateFlowMapPath",param);
		    IDataCursor curFlowMapPath = IDataFlowMapPath.getCursor();
		    IData resFlowMapPath = IDataUtil.getIData(curFlowMapPath,"invalidMapPath");
		    curNodeService.destroy();
		
		    if( resFlowMapPath != null ) {
		    	IDataCursor curResFlowMapPath = resFlowMapPath.getCursor();
		    	IData[] reference = IDataUtil.getIDataArray(curResFlowMapPath,"reference");
		    	curResFlowMapPath.destroy();
		
		    	for(int i=0; reference != null && i<reference.length; i++) {
			    IData ref = reference[i];
			    IDataCursor curRef =  ref.getCursor();
		            String nameUn = IDataUtil.getString(curRef,"name");
			    analyzeDataForError("la r\u00e9f\u00e9rence n'existe pas", "/", nameUn, "unresolved", alErrors);
			    curRef.destroy();
		    	}
		    }
			
		    int iErrors = alErrors.size();
		    if( iErrors > 0 ) {
		    	IData[] errors = new IData[iErrors];
			IData[] flError = new IData[1];
			flError[0] = IDataFactory.create();
			IDataCursor curFlError = flError[0].getCursor();
			curFlError.insertAfter("name", name);
			curFlError.insertAfter("pkg", pkg);
			curFlError.insertAfter("errors", (IData[]) alErrors.toArray(errors));
			curFlError.destroy();
		
			IDataUtil.remove(cursor, "FlowError");
			if( flowError != null && flowError.length > 0 ) {
			    IData[] flErrorNew = new IData[flowError.length + 1 ];
			    System.arraycopy(flowError, 0, flErrorNew, 0,  flowError.length );
			    flErrorNew[flowError.length] = flError[0];
			    cursor.insertAfter("FlowError", flErrorNew);		
			} else {
			    cursor.insertAfter("FlowError", flError);
			}
		    }
		    cursor.destroy();
		} catch(Exception ex) {
		    throw new ServiceException("[Erreur dans AnalyzeFlowService] : " + name + " " +ex.toString());
		}
		// --- <<IS-END>> ---

                
	}



	public static final void AnalyzeJavaService (IData pipeline)
        throws ServiceException
	{
		// --- <<IS-START(AnalyzeJavaService)>> ---
		// @subtype unknown
		// @sigtype java 3.5
		// [i] field:0:required name
		// [i] field:0:required pkg
		// [o] record:1:required JavaError
		// [o] - field:0:required name
		// [o] - field:0:required pkg
		// [o] - field:1:required error_type
		try {
		    IDataCursor cursor 		= pipeline.getCursor();
		    String	name   		= IDataUtil.getString(cursor,"name");
		    String	pkg		= IDataUtil.getString(cursor,"pkg");
		    IData[]     javaError	= IDataUtil.getIDataArray(cursor,"JavaError");
		    
		    int pkgSep = name.indexOf(":");
		    String javaPackage = name.substring(0,pkgSep);
		    String javaMethod = name.substring(pkgSep + 1, name.length());
		    ArrayList alErrors = new ArrayList();
		
		    String classFile = getFullClassName(pkg, javaPackage);
		    if( !(new File(classFile)).exists()) {
			alErrors.add("Probl\u00e8me de compilation pour : " + javaPackage);
		    } else {
		    	JavaClass java_class = new ClassParser(classFile).parse();
		    	Method[] meth = java_class.getMethods();
		    	for(int i=0;i<meth.length;i++) {
			    String methName = meth[i].getName();
		
			    if(methName.equals(javaMethod)) {
			    	if( meth[i].getLineNumberTable().getTableLength() == 1 ) {
				    alErrors.add("Le service n'a pas de contenu");
			    	} else {
			    	    String[] propJava = QA.mng.PropManager.getJavaContentToCheck();
			    	    if( propJava != null ) {
				    	String javaContent = Utility.codeToString(meth[i].getCode().getCode(), 
					    meth[i].getCode().getConstantPool(), 0, -1, false);
				    	for(int iProp=0; iProp<propJava.length; iProp++) {
				    	    String contentToTest =  propJava[iProp];
				    	    if(javaContent.indexOf(contentToTest) != -1 )
				    	    	alErrors.add("Le service contient : " + contentToTest);
				    	}
				    }
			    	}	    
			    }
		    	}
		    }
		
		    int iErrors = alErrors.size();
		    if( iErrors > 0 ) {
		    	String[] errors = new String[iErrors];
			IData[] jvError = new IData[1];
			jvError[0] = IDataFactory.create();
			IDataCursor curJvError = jvError[0].getCursor();
		
			curJvError.insertAfter("name", name);
			curJvError.insertAfter("pkg", pkg);
			curJvError.insertAfter("error_type", (String[]) alErrors.toArray(errors));
			curJvError.destroy();
		
			IDataUtil.remove(cursor, "JavaError");
			if( javaError != null && javaError.length > 0 ) {
			    IData[] javaErrorNew = new IData[javaError.length + 1 ];
			    System.arraycopy(javaError, 0, javaErrorNew, 0,  javaError.length );
			    javaErrorNew[javaError.length] = jvError[0];
			    cursor.insertAfter("JavaError", javaErrorNew);		
			} else {
			    cursor.insertAfter("JavaError", jvError);
			}
		    }
		    cursor.destroy();
		} catch(Exception ex) {
		    throw new ServiceException("[Erreur dans AnalyzeJavaService] : " + ex.toString());
		}
		// --- <<IS-END>> ---

                
	}



	public static final void AnalyzePackage (IData pipeline)
        throws ServiceException
	{
		// --- <<IS-START(AnalyzePackage)>> ---
		// @subtype unknown
		// @sigtype java 3.5
		// [i] field:0:required pkg
		// [o] record:1:required PackageError
		// [o] - field:0:required pkg
		// [o] - field:1:required error_type
		// [o] - field:1:optional successors
		try {
		    IDataCursor cursor 		= pipeline.getCursor();
		    String	pkg		= IDataUtil.getString(cursor,"pkg");
		    IData[]     pkgErrors	= IDataUtil.getIDataArray(cursor,"PackageError");
		
		    IDataUtil.remove(cursor, "pkg");
		
		    ArrayList alErrors = new ArrayList();
		    ArrayList alSuccessors = new ArrayList();
		
		    IData param = IDataFactory.create();
		    IDataCursor curParam = param.getCursor();
		    curParam.insertAfter("package", pkg);
		    curParam.destroy();
		
		    IData nodeService = Service.doInvoke("wm.server.packages","packageInfo",param);
		    IDataCursor curNodeService = nodeService.getCursor();
		    String[] propPackage = QA.mng.PropManager.getPackageConfigToCheck();
		    boolean configsuccessors = false;
		
		    if( propPackage != null ) {
			for(int iProp=0; iProp<propPackage.length; iProp++) {
			    String valCheck 	=  propPackage[iProp];
			    if( valCheck.equalsIgnoreCase("config-successors") ) 
				configsuccessors = "true".equalsIgnoreCase(PropManager.getProperty(valCheck,PropManager.PACKAGE_PROPERTIES));
		
			    if( !valCheck.startsWith("config-")) {
			    	String curValue 	= IDataUtil.getString(curNodeService,valCheck);
			    	String confValue	= PropManager.getProperty(valCheck,PropManager.PACKAGE_PROPERTIES);
			    	if((!confValue.equals(curValue) && !confValue.equals("null")) || (confValue.equals("null") && curValue!=null)) {
				    alErrors.add("Probl\u00e8me de configuration : " + valCheck + "=" + curValue + " au lieu de " + confValue);
			   	}
			    }
			}
		    }
		
		    IData paramList = IDataFactory.create();
		    IDataCursor curParamList = paramList.getCursor();
		    curParamList.insertAfter("packageName", pkg);
		    
		    QA.QAServices.ListPackageDependency(paramList);
		    String[] successors = IDataUtil.getStringArray(curParamList,"successors");
		    String[] not_found = IDataUtil.getStringArray(curParamList,"not_found");
		    curParamList.destroy();
		
		    for(int ifound=0; (not_found != null && ifound<not_found.length); ifound++) {
			alErrors.add(not_found[ifound]);
		    }
		
		    if( configsuccessors ) {
		    	String[] pkgsuccessors = IDataUtil.getStringArray(curNodeService,"successors");
		
		   	//Packages manquants
		    	for(int isuccess=0; (successors != null && isuccess<successors.length); isuccess++) {
			    if( pkgsuccessors == null ) {
			    	addSuccessorError(alSuccessors, "Missing : " + successors[isuccess]);
			    } else {
			    	boolean found = false;
			    	for(int iactual=0; (pkgsuccessors != null && iactual<pkgsuccessors.length && !found); iactual++) {
				    found = pkgsuccessors[iactual].startsWith(successors[isuccess] + ";");
			    	}
		
			    	if( !found ) addSuccessorError(alSuccessors, "Missing : " + successors[isuccess]);
			    }
			}
		
		
		    	//Packages en trop
		    	for(int iactual=0; (pkgsuccessors != null && iactual<pkgsuccessors.length ); iactual++) {
			    boolean found = false;
			    for(int isuccess=0; (successors != null && isuccess<successors.length && !found); isuccess++) {
			    	found = pkgsuccessors[iactual].startsWith(successors[isuccess] + ";");
			    }
		            if( !found ) addSuccessorError(alSuccessors, "Remove : " + pkgsuccessors[iactual]);
		    	}
		    }
		    curNodeService.destroy();	
		    
		
		
		    //successors et version
		
		    int iErrors = alErrors.size();
		    if( iErrors > 0 || alSuccessors.size() > 0) {
		    	String[] errors = new String[iErrors];
			String[] succ = new String[alSuccessors.size()];
		
			IData[] pkgError = new IData[1];
			pkgError[0] = IDataFactory.create();
			IDataCursor curPkgError = pkgError[0].getCursor();
		
			curPkgError.insertAfter("pkg", pkg);
			if( iErrors > 0 ) curPkgError.insertAfter("error_type", (String[]) alErrors.toArray(errors));
			if( alSuccessors.size() > 0 ) curPkgError.insertAfter("successors", (String[]) alSuccessors.toArray(succ));
		
			curPkgError.destroy();
		
			IDataUtil.remove(cursor, "PackageError");
			if( pkgErrors != null && pkgErrors.length > 0 ) {
			    IData[] pkgErrorNew = new IData[pkgErrors.length + 1 ];
			    System.arraycopy(pkgErrors, 0, pkgErrorNew, 0,  pkgErrors.length );
			    pkgErrorNew[pkgErrors.length] = pkgError[0];
			    cursor.insertAfter("PackageError", pkgErrorNew);		
			} else {
			    cursor.insertAfter("PackageError", pkgError);
			}
		    }
		    curNodeService.destroy();
		    cursor.destroy();
		} catch(Exception ex) {
		    throw new ServiceException("[Erreur dans AnalyzePackage] : " + ex.toString());
		}
		// --- <<IS-END>> ---

                
	}



	public static final void AnalyzeServiceConfig (IData pipeline)
        throws ServiceException
	{
		// --- <<IS-START(AnalyzeServiceConfig)>> ---
		// @subtype unknown
		// @sigtype java 3.5
		// [i] field:0:required name
		// [i] field:0:required pkg
		// [i] field:0:required type
		// [o] record:1:required ServiceConfigError
		// [o] - field:0:required name
		// [o] - field:0:required pkg
		// [o] - field:1:required error_type
		try {
		    IDataCursor cursor 		= pipeline.getCursor();
		    String	name   		= IDataUtil.getString(cursor,"name");
		    String	pkg		= IDataUtil.getString(cursor,"pkg");
		    String	type		= IDataUtil.getString(cursor,"type");
		    IData[]     flowConfig	= IDataUtil.getIDataArray(cursor,"ServiceConfigError");
		
		    IDataUtil.remove(cursor, "type");
		    ArrayList alErrors = new ArrayList();
		
		    IData param = IDataFactory.create();
		    IDataCursor curParam = param.getCursor();
		    curParam.insertAfter("name", name);
		    curParam.destroy();
		
		    IData nodeService = Service.doInvoke("wm.server.ns","getNode",param);
		    IDataCursor curNodeService = nodeService.getCursor();
		    Object nodeType = IDataUtil.get(curNodeService,"node");
		    curNodeService.destroy();
		    Values v =((BaseService) nodeType).getNodeValues();
		
		    NSSignature nsSign = (NSSignature) v.get(NSSignature.KEY_NSSi_IN); //sig_in
		    if( nsSign != null ) {
		    	Values svc_sig = nsSign.getValues();
		    	analyzeSignature(svc_sig, alErrors);
		    }
		
		    String[] propConfig = QA.mng.PropManager.getServiceConfigToCheck(type);
		    if( propConfig != null ) {
			for(int iProp=0; iProp<propConfig.length; iProp++) {
			    String configToTest =  propConfig[iProp];
			    String curValue 	= (String) v.get(configToTest);
			    String confValue	= QA.mng.PropManager.getProperty("config-" + configToTest,type);
			    if(!confValue.equals(curValue)) {
				alErrors.add("Probl\u00e8me de configuration : " + configToTest + "=" + curValue + " au lieu de " + confValue);
			    }
			}
		    }
		
		    int iErrors = alErrors.size();
		    if( iErrors > 0 ) {
		    	String[] errors = new String[iErrors];
			IData[] cfError = new IData[1];
			cfError[0] = IDataFactory.create();
			IDataCursor curCfError = cfError[0].getCursor();
		
			curCfError.insertAfter("name", name);
			curCfError.insertAfter("pkg", pkg);
			curCfError.insertAfter("error_type", (String[]) alErrors.toArray(errors));
			curCfError.destroy();
		
			IDataUtil.remove(cursor, "ServiceConfigError");
			if( flowConfig != null && flowConfig.length > 0 ) {
			   IData[] flConfigNew = new IData[flowConfig.length + 1 ];
			    System.arraycopy(flowConfig, 0, flConfigNew, 0,  flowConfig.length );
			    flConfigNew[flowConfig.length] = cfError[0];
			    cursor.insertAfter("ServiceConfigError", flConfigNew);		
			} else {
			    cursor.insertAfter("ServiceConfigError", cfError);
			}
		    }
		   
		    cursor.destroy();
		} catch(Exception ex) {
		    throw new ServiceException("[Erreur dans AnalyzeFlowService] : " + ex.toString());
		}
		// --- <<IS-END>> ---

                
	}



	public static final void AnalyzeTrigger (IData pipeline)
        throws ServiceException
	{
		// --- <<IS-START(AnalyzeTrigger)>> ---
		// @subtype unknown
		// @sigtype java 3.5
		// [i] field:0:required name
		// [i] field:0:required pkg
		// [o] record:1:required TriggerError
		// [o] - field:0:required name
		// [o] - field:0:required pkg
		// [o] - field:1:required error_type
		try {
		    IDataCursor cursor 		= pipeline.getCursor();
		    String	name   		= IDataUtil.getString(cursor,"name");
		    String	pkg		= IDataUtil.getString(cursor,"pkg");
		    IData[]     triggerError	= IDataUtil.getIDataArray(cursor,"TriggerError");
		
		    IDataUtil.remove(cursor, "name");
		    //IDataUtil.remove(cursor, "pkg");
		
		    ArrayList alErrors = new ArrayList();
		
		    IData param = IDataFactory.create();
		    IDataCursor curParam = param.getCursor();
		    curParam.insertAfter("name", name);
		    curParam.destroy();
		
		    IData nodeService = Service.doInvoke("wm.server.ns","getNode",param);
		    IDataCursor curNodeService = nodeService.getCursor();
		    NSTrigger trigger = (NSTrigger) IDataUtil.get(curNodeService,"node");
		    Values valTrigger = (Values) trigger.getValues().get("trigger");
		    curNodeService.destroy();
		
		    String[] propTrigger = QA.mng.PropManager.getTriggerConfigToCheck();
		
		    if( propTrigger != null ) {
			for(int iProp=0; iProp<propTrigger.length; iProp++) {
			    String valCheck 	=  propTrigger[iProp];
			    String curValue 	= (String) valTrigger.get(valCheck);
			    String confValue	= QA.mng.PropManager.getProperty(valCheck,"trigger.conf");
			    if(!curValue.equals(confValue)) {
				alErrors.add("Probl\u00e8me de configuration : " + valCheck + "=" + curValue + " au lieu de " + confValue);
			    }
			}
		    }
		
		    int iErrors = alErrors.size();
		    if( iErrors > 0 ) {
		    	String[] errors = new String[iErrors];
			IData[] trgError = new IData[1];
			trgError[0] = IDataFactory.create();
			IDataCursor curTrgError = trgError[0].getCursor();
		
			curTrgError.insertAfter("name", name);
			curTrgError.insertAfter("pkg", pkg);
			curTrgError.insertAfter("error_type", (String[]) alErrors.toArray(errors));
			curTrgError.destroy();
		
			IDataUtil.remove(cursor, "TriggerError");
			if( triggerError != null && triggerError.length > 0 ) {
			    IData[] trgErrorNew = new IData[triggerError.length + 1 ];
			    System.arraycopy(triggerError, 0, trgErrorNew, 0,  triggerError.length );
			    trgErrorNew[triggerError.length] = trgError[0];
			    cursor.insertAfter("TriggerError", trgErrorNew);		
			} else {
			    cursor.insertAfter("TriggerError", trgError);
			}
		    }
		    //cursor.insertAfter("out", valTrigger);	
		    cursor.destroy();
		} catch(Exception ex) {
		    throw new ServiceException("[Erreur dans AnalyzeTrigger] : " + ex.toString());
		}
		// --- <<IS-END>> ---

                
	}

	// --- <<IS-START-SHARED>> ---
	public static final String SEP = System.getProperty("file.separator");
	
	public static class ClassFilter implements FileFilter {
	    public String fStart = "";
		public ClassFilter(String fStart) {this.fStart = fStart;}
	
	    public boolean accept(File file) {
			try {
				String fName = file.getCanonicalPath();
				// Certaines classes contiennent des sous classes ma_classe$1.class 
				return fName.startsWith(fStart + "$") && !fName.startsWith(fStart + "$1.");
			} catch (Exception ex) {
				return false;
			}
		}
	}
	
	public static class ClassPackage {
		private String packageName;
		private ArrayList alClasses = new ArrayList();
	
		public ClassPackage(String packageName) {this.packageName=packageName;}
		public String getPackageName() {return packageName;}
	
		public void setClass(String className) {
			if( !alClasses.contains(className) ) alClasses.add(className);
		}
	
		public String[] getClassList() {
			if( alClasses.size() > 0 ) {
				String[] classes = new String[alClasses.size()];
				return (String[]) alClasses.toArray(classes);
			} else {
				return null;
			}
		}
	}
	
	private static String fillClassMethods(String curClass, String meth, String code, HashMap hmClass) {
		if( !meth.equals("<init>") &&
			!meth.equals("_newInstance") &&
			!meth.equals("_cast") &&
			!meth.equals("<clinit>") ) {
	
			String newMeth = curClass + "." + meth;
			hmClass.put(newMeth, code);
			return newMeth;
		}  else {
			return null;
		}
	}
	
	private static final void addSuccessorError(ArrayList alSuccessors, String value) {
		if( !alSuccessors.contains(value)) alSuccessors.add(value);
	}
	
	private static final void analyzeFlowElement(String path, FlowElement fe, ArrayList alErrors) throws Exception{
		int nbItem = fe.getNodeCount();
		Values val = fe.getValues();
		String name = (String) val.get(NSService.TYPE_KEY); //service
	    String disabled = (String) val.get(FlowElement.KEY_ELEMENT_DISABLED); //disabled
	    String type = fe.getFlowType(); 
	    String object_name;
	
	    if( FlowElement.TYPE_INVOKE.equals(type) )
			object_name = (String)fe.getValues().get(NSService.TYPE_KEY); //service	
		else
			object_name = type;
	
	    if( "true".equals(disabled)) 
			analyzeDataForError("Etape desactiv\u00e9e", path, object_name, type, alErrors);
		
		if( name != null && disabled == null) {
			String[] propFlow = QA.mng.PropManager.getFlowContentToCheck();
			if( propFlow != null ) {
				for(int iProp=0; iProp<propFlow.length; iProp++) {
					String srv = "pub.flow:" + propFlow[iProp];
					if( srv.equals(name) )
						analyzeDataForError("Etape non supprim\u00e9e", path, object_name, type, alErrors);
			    }
			}
		}
	
	    for(int i=0; i<nbItem; i++) {
			analyzeFlowElement(path + fe.getFlowType() + "/", fe.getNodeAt(i), alErrors);
		}
	}
	
	private static final void analyzeDataForError(
		String errorType, String path, String object_name, String object_type, ArrayList alErrors) {
			IData param = IDataFactory.create();
			IDataCursor curParam = param.getCursor();
			curParam.insertAfter("object_name", object_name);
			curParam.insertAfter("object_type", object_type);	
			curParam.insertAfter("error_type", errorType);	
		    curParam.insertAfter("error_path", path);		
			curParam.destroy();
			alErrors.add(param);
	}
	
	//R\u00e9cup\u00e9ration du chemin complet d'une classe d'un package
	private static String getFullClassName(String pkgName, String javaPkg) throws java.io.IOException {
	    String javaPackage = javaPkg.replace('.','/');
		File dirConfig = ServerAPI.getPackageConfigDir(pkgName);
	    String fullDirName = dirConfig.getCanonicalPath();
		return new File(fullDirName, ".." + SEP + "code" + SEP + "classes" + SEP + javaPackage + ".class").getCanonicalPath();
	}
	
	//R\u00e9cup\u00e9ration des classes publiques d'une classe d'un package
	private static String[] getFullIncludedClassName(String curClass) throws java.io.IOException {
	    String folder = curClass.substring(0, curClass.lastIndexOf(SEP));
	    String fStart = curClass.substring(0, curClass.indexOf(".class") );
		// This filter only returns directories
	    ClassFilter fileFilter = new ClassFilter(fStart);
		File[] files = new File(folder).listFiles(fileFilter);
		String[] sFiles = null;
		if( files != null ) {
			sFiles = new String[files.length];
			for(int i=0; i<files.length; i++) 
				sFiles[i] = files[i].getCanonicalPath();
		}
		return sFiles;
	}
	
	private static void analyzeSignature(Values srvSig, ArrayList alErrors) throws Exception {
	    Values sig_in  = ((NSRecord) srvSig.get(NSSignature.KEY_NSSi_IN)).getValues(); //sig_in
	    Values[] rec_fields_in = (Values[])sig_in.get(NSRecord.KEY_NSR_FIELDS); //rec_fields
	
		analyzeDetailSignature(rec_fields_in, "SIGNATURE_IN", alErrors);
	
	    Values sig_out  = ((NSRecord) srvSig.get(NSSignature.KEY_NSSi_OUT)).getValues(); //sig_out
	    Values[] rec_fields_out = (Values[])sig_out.get(NSRecord.KEY_NSR_FIELDS); //rec_fields
	
		analyzeDetailSignature(rec_fields_out, "SIGNATURE_OUT", alErrors);
	}
	
	private static void analyzeDetailSignature(Values[] rec_fields, String type, ArrayList alErrors) throws Exception {
		for(int i=0; rec_fields!=null && i<rec_fields.length; i++) {
	
			NSName rec_ref = (NSName) rec_fields[i].get("rec_ref");
			if( rec_ref != null ) {
				String field_name = (String) rec_fields[i].get(NSField.KEY_NSF_NAME); //field_name
				if( !rec_ref.getValue().equals(field_name) ) {
					alErrors.add(type + ": >" + field_name + "< le param\u00e8tre ne porte pas le m\u00eame nom que sa r\u00e9f\u00e9rence");
				}
				IData param = IDataFactory.create();
	    		IDataCursor curParam = param.getCursor();
	    		curParam.insertAfter("name", rec_ref.getValue());
	    		curParam.destroy();
	
				IData nodeService = Service.doInvoke("wm.server.ns","getNode",param);
				IDataCursor curNodeService = nodeService.getCursor();
	    		Object nodeType = IDataUtil.get(curNodeService,"node");
	    		curNodeService.destroy();
	
				if( nodeType == null ) {
					alErrors.add(type + ": >" + rec_ref.getValue() + "< la r\u00e9f\u00e9rence n'existe pas !");
				}
			}
		}
	}
	// --- <<IS-END-SHARED>> ---
}

