package QA;

// -----( IS Java Code Template v1.2
// -----( CREATED: 2005-07-22 14:43:40 MEST
// -----( ON-HOST: loki

import com.wm.data.*;
import com.wm.util.Values;
import com.wm.app.b2b.server.Service;
import com.wm.app.b2b.server.ServiceException;
// --- <<IS-START-IMPORTS>> ---
import com.wm.app.b2b.server.ServerAPI;
import java.io.File;
import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Vector;
import java.util.ArrayList;
import java.util.Enumeration;
import QA.mng.PropManager;
// --- <<IS-END-IMPORTS>> ---

public final class QAConfig

{
	// ---( internal utility methods )---

	final static QAConfig _instance = new QAConfig();

	static QAConfig _newInstance() { return new QAConfig(); }

	static QAConfig _cast(Object o) { return (QAConfig)o; }

	// ---( server methods )---




	public static final void load (IData pipeline)
        throws ServiceException
	{
		// --- <<IS-START(load)>> ---
		// @subtype unknown
		// @sigtype java 3.5
		QA.mng.PropManager.getProperties("flowservice.conf");
		QA.mng.PropManager.getProperties("javaservice.conf");
		QA.mng.PropManager.getProperties("package.conf");
		QA.mng.PropManager.getProperties("trigger.conf");
		// --- <<IS-END>> ---

                
	}



	public static final void parseConfigfile (IData pipeline)
        throws ServiceException
	{
		// --- <<IS-START(parseConfigfile)>> ---
		// @sigtype java 3.5
		// [i] field:0:required fileName
		// [o] record:1:required Properties
		// [o] - field:0:required Name
		// [o] - field:0:required Value
		// [o] - field:0:required Type
		// [o] - field:0:required Config
		// [o] - field:0:required Desc
		// [o] - field:0:required FlagDesc
		try {       
		  IDataCursor pipelineCursor = pipeline.getCursor();       
		  String      fileName       = IDataUtil.getString(pipelineCursor,"fileName");
		     
		  Vector paramName = new Vector();       
		  Vector paramValue = new Vector();       
		  Vector paramType = new Vector();     
		  Vector paramConfig = new Vector();    
		  Vector paramComment = new Vector();       
		  Vector paramFlagComment = new Vector();       
		       
		  String line = "";       
		  String lineComment = "";
		
		    java.io.FileReader fileR = new java.io.FileReader(getFileConfig(fileName));       
		    java.io.LineNumberReader lineR = new java.io.LineNumberReader(fileR);       
		    boolean b = true;       
		         
		    while ( b ) {       
		         
		      line = lineR.readLine();           
		  
		      if ( line == null ) {       
		        b = false;       
		      }       
		     
		     
		      if ( line != null && !line.equals("") && !line.equals("\n") && !line.equals("\r")) {       
		        if ( line.startsWith("#")  ) {       
		          if ( line.startsWith("#1") || line.startsWith("#2") || line.startsWith("#3") ) {       
		              paramName.add("");       
		              paramConfig.add(fileName);
		              String value = "" + line.substring(3,line.length()-1);   
		              value = replace(value, "'", "&acute;");   
		              paramValue.add(value);   
		              paramType.add("Titre" + line.substring(1,2));   
		              paramComment.add("");   
		              paramFlagComment.add("false");      
		          } else {       
		            if (line.startsWith("#C")) {       
		              lineComment = line.substring(3, line.length()-1);       
		              line = lineR.readLine();       
		              java.util.StringTokenizer stLine = new java.util.StringTokenizer(line, "=");       
		              if (stLine.hasMoreTokens()) {       
		                paramName.add("" + stLine.nextToken());       
		              } else {       
		                paramName.add("");       
		              }       
		              if (stLine.hasMoreTokens()) {       
		                paramValue.add(stLine.nextToken());       
		              } else {       
		                paramValue.add("");       
		              }       
		              paramType.add("Param");   
		              paramConfig.add(fileName);    
		              paramComment.add(lineComment);       
		              paramFlagComment.add("true");       
		            }  else {      
		              paramName.add("");   
		              String value = "" + line.substring(1,line.length());   
		              value = replace(value, "'", "&acute;");   
		              paramValue.add(value);       
		              paramType.add("Titre1"); 
		              paramConfig.add(fileName);         
		              paramComment.add("");       
		              paramFlagComment.add("false");       
		            }   
		          }       
		        } else {       
		          int t = line.indexOf("=");   
		          paramName.add(line.substring(0,t));       
		          String value = line.substring(t+1,line.length());   
		          value = replace(value, "\"", "&quot;");   
		          paramValue.add(value);       
		          paramType.add("Param");    
		          paramConfig.add(fileName);      
		          paramComment.add("");       
		          paramFlagComment.add("false");       
		        }       
		      }       
		    }       
		         
		    lineR.close();   
		    fileR.close();   
		   
		  int N = paramName.size();       
		       
		  IData[]  parameters = new IData[N];       
		  for (int k=0; k<N; k++) {       
		       
		    parameters[k] = IDataFactory.create();       
		    IDataCursor parametersCursor = parameters[k].getCursor();       
		    IDataUtil.put( parametersCursor, "Name", paramName.get(k) );       
		    IDataUtil.put( parametersCursor, "Value", paramValue.get(k) );       
		    IDataUtil.put( parametersCursor, "Type", paramType.get(k) );  
		    IDataUtil.put( parametersCursor, "Config", paramConfig.get(k) );     
		    IDataUtil.put( parametersCursor, "Desc", paramComment.get(k) );       
		    IDataUtil.put( parametersCursor, "FlagDesc", paramFlagComment.get(k) );       
		    parametersCursor.destroy();       
		       
		  }        
		  IDataUtil.put( pipelineCursor, "Properties", parameters );       
		  pipelineCursor.destroy();       
		       
		} catch (Exception e) {       
		  throw new ServiceException(e.getMessage());       
		}       
		// --- <<IS-END>> ---

                
	}



	public static final void saveProperties (IData pipeline)
        throws ServiceException
	{
		// --- <<IS-START(saveProperties)>> ---
		// @subtype unknown
		// @sigtype java 3.5
		// [i] field:0:required needSave
		// [o] field:0:required Status
		
		IDataCursor pipelineCursor = pipeline.getCursor();
		//-------------------------------------------------------------------------------------------
		// Extraction des param\u00e8tres
		//-------------------------------------------------------------------------------------------
		
		ByteArrayOutputStream _Baos = new ByteArrayOutputStream();
		String sStatus = "ok";
		//System.out.println("----------------" + (new java.util.Date()));
		String fileName=null;
		FileOutputStream _fos = null;
		try {
		      String      name           = IDataUtil.getString(pipelineCursor,"name");
			//-------------------------------------------------------------------------------------------
			// Construction du fichier de propri\u00e9t\u00e9s
			//-------------------------------------------------------------------------------------------
			for( ; pipelineCursor.hasMoreData() ; ) {
				pipelineCursor.next();
		  		String curKey = pipelineCursor.getKey();
				if( curKey.equals("needSave") )
					if( !pipelineCursor.getValue().equals("true") ) break;
					else continue;
				if(curKey.endsWith("List") )
					continue;
		
				if(curKey.startsWith("Menu.") )
					continue;
				String reqvalue = (String)pipelineCursor.getValue();
				if( curKey.startsWith("fileName.") ) {
				    if(_fos != null) {
					_fos.write(_Baos.toByteArray());
					_fos.close();
				    }
				    _fos = new FileOutputStream(getFileConfig(reqvalue));
				    _Baos = new ByteArrayOutputStream();
				    continue;
				}
		
				String rcdKey = curKey.substring(curKey.indexOf(".") + 1, curKey.length());
				String propertyLine = rcdKey + "=" + reqvalue + "\n";
		//System.out.print("propertyLine : " + propertyLine);
		
				_Baos.write(propertyLine.getBytes());
			} 
		
			//-------------------------------------------------------------------------------------------
			// Enregistrement du fichier de propri\u00e9t\u00e9s
			//-------------------------------------------------------------------------------------------
		
				    if(_fos != null) {
					_fos.write(_Baos.toByteArray());
					_fos.close();
				    }
		
			//FileOutputStream _fos = new FileOutputStream(getFileConfig(name), false);
			//_fos.write(_Baos.toByteArray());
			//_fos.close();
		
			//-------------------------------------------------------------------------------------------
			// Rechargement des propri\u00e9t\u00e9s
			//-------------------------------------------------------------------------------------------
		    QA.mng.PropManager.reset();
		
		    IData param = IDataFactory.create();
		    IDataCursor curParam = param.getCursor();
		    curParam.insertAfter("package", "QA");
		    curParam.destroy();
		
		    Service.doInvoke("wm.server.packages","packageReload",param);
		
		}
		 catch( Exception e ) {	
			sStatus = "ko";
		}
		
		//-------------------------------------------------------------------------------------------
		// Construction des param\u00e8tres de sortie
		//-------------------------------------------------------------------------------------------
		
		IDataUtil.put( pipelineCursor, "Status", sStatus );
		
		pipelineCursor.destroy();
		// --- <<IS-END>> ---

                
	}

	// --- <<IS-START-SHARED>> ---
	//Construction d'un objet File, dans le r\u00e9pertoire config d'un package
	public static File getFileConfig(String name) throws java.io.IOException {
		File dirConfig = ServerAPI.getPackageConfigDir("QA");
	    String fullDirName = dirConfig.getCanonicalPath();
		return new File(fullDirName, name);
	}
	
	public static String replace(String chaine, String oldChar, String newChar) throws Exception {
	
		String rtnString = chaine;
		java.util.StringTokenizer stChaine = new java.util.StringTokenizer(chaine, oldChar);
		if (stChaine.hasMoreTokens()) {
			rtnString = stChaine.nextToken();
		}
		while (stChaine.hasMoreTokens()) {
			rtnString += newChar + stChaine.nextToken();
		}
	
		return rtnString;
	}
	// --- <<IS-END-SHARED>> ---
}

