package QA;

// -----( IS Java Code Template v1.2
// -----( CREATED: 2006-09-08 11:04:57 CEST
// -----( ON-HOST: dmd01

import com.wm.data.*;
import com.wm.util.Values;
import com.wm.app.b2b.server.Service;
import com.wm.app.b2b.server.ServiceException;
// --- <<IS-START-IMPORTS>> ---
import java.io.File;
import com.wm.app.b2b.server.ServerAPI;
// --- <<IS-END-IMPORTS>> ---

public final class QAInit

{
	// ---( internal utility methods )---

	final static QAInit _instance = new QAInit();

	static QAInit _newInstance() { return new QAInit(); }

	static QAInit _cast(Object o) { return (QAInit)o; }

	// ---( server methods )---




	public static final void getInfoForMenu (IData pipeline)
        throws ServiceException
	{
		// --- <<IS-START(getInfoForMenu)>> ---
		// @subtype unknown
		// @sigtype java 3.5
		IDataCursor cursor = pipeline.getCursor();
		IDataUtil.put(cursor, "name", "QA Manager");
		IDataUtil.put(cursor, "text", "QA Manager");
		IDataUtil.put(cursor, "url", "/QA/index.dsp");
		IDataUtil.put(cursor, "target", "top");
		cursor.destroy();
		// --- <<IS-END>> ---

                
	}



	public static final void startup (IData pipeline)
        throws ServiceException
	{
		// --- <<IS-START(startup)>> ---
		// @subtype unknown
		// @sigtype java 3.5
		IData idata = IDataFactory.create();
		IDataCursor cursor = idata.getCursor();
		
		try {
			if ( !isHidden() ) {
				cursor.insertAfter("callback", "QA.QAInit:getInfoForMenu");
				cursor.destroy(); 
		    		Service.doInvoke("wm.server.ui", "addSolution", idata);
			}
		} catch(Exception e) {
		  	throw new ServiceException(e);
		}
		
		// --- <<IS-END>> ---

                
	}

	// --- <<IS-START-SHARED>> ---
	public static boolean isHidden() throws java.io.IOException {
		File dirConfig = ServerAPI.getPackageConfigDir("QA");
	    String fullDirName = dirConfig.getCanonicalPath();
	    File hidden = new File(fullDirName, "HIDDEN");
	
		return (hidden != null && hidden.exists());
	}
	
	
	public static final void logger(String s)
		throws ServiceException {
	
	        logger(s, null, null);
	}
	
	public static final void logger(String s, String s1)
		throws ServiceException {
	
	        logger(s, s1, null);
	}
	
	
	public static final void logger(String s, String s1, String s2)
		throws ServiceException {
	
		Values values = new Values();
		if(s != null)
			values.put("message", "[Thread : " + Thread.currentThread().getName() + "] Message : " +s);
		if(s1 != null)
			values.put("function", s1);
		if(s2 != null)
			values.put("level", s2);
		try {
			Service.doInvoke("pub.flow", "debugLog", values);
		} catch(Exception exception) {
			throw new ServiceException(exception.getMessage());
		}
	}
	// --- <<IS-END-SHARED>> ---
}

