package QA;

// -----( IS Java Code Template v1.2
// -----( CREATED: 2005-12-16 14:52:54 MET
// -----( ON-HOST: miniLoki2.

import com.wm.data.*;
import com.wm.util.Values;
import com.wm.app.b2b.server.Service;
import com.wm.app.b2b.server.ServiceException;
// --- <<IS-START-IMPORTS>> ---
import com.wm.app.b2b.broker.sync.BrokerSynchronizer;
import com.wm.lang.ns.NSRecord;
import com.wm.lang.ns.EventDescription;
import COM.activesw.api.client.BrokerAdminClient;
import com.wm.app.b2b.server.PackageFS;
import com.wm.lang.ns.NSName;
import java.util.ArrayList;
import com.wm.lang.ns.NSPackage;
import java.util.Vector;
import java.util.Enumeration;
import com.wm.lang.ns.NSNode;
import com.wm.app.b2b.util.ServerIf;
import java.util.HashMap;
import com.wm.app.b2b.server.ServerAPI;
import java.io.File;
import java.io.FileFilter;
// --- <<IS-END-IMPORTS>> ---

public final class QARepair

{
	// ---( internal utility methods )---

	final static QARepair _instance = new QARepair();

	static QARepair _newInstance() { return new QARepair(); }

	static QARepair _cast(Object o) { return (QARepair)o; }

	// ---( server methods )---




	public static final void RebuildPackage (IData pipeline)
        throws ServiceException
	{
		// --- <<IS-START(RebuildPackage)>> ---
		// @subtype unknown
		// @sigtype java 3.5
		// [i] field:0:optional packageName
		try {
		    IDataCursor cursor 		= pipeline.getCursor();
		    String	packageName	= IDataUtil.getString(cursor,"packageName");
		    NSPackage[] pkg         	= com.wm.app.b2b.server.ns.Namespace.current().getAllPackages();
		
		    ArrayList alClasses = new ArrayList();
		    for(int i=0; i<pkg.length; i++) {
			String pkgName = pkg[i].getName();
		
		    	if(!pkgName.startsWith("SAP") && !pkgName.startsWith("Wm") && !pkgName.startsWith("QA") && (packageName == null || pkgName.equals(packageName))) {
		     	    Vector list = com.wm.app.b2b.server.ns.Namespace.current().getNodes(new com.wm.app.b2b.server.Package(pkgName));
		      	    Enumeration enum = list.elements();
		      	    while(enum.hasMoreElements()) {
		            	NSNode node = (NSNode)enum.nextElement();
				String nodeName = node.getNSName().getValue();
		   		String typeName = node.getNodeTypeObj().getValue();
		
				if(typeName.equals(ServerIf.KEY_SERVICE_NAME)) {
		
		                    IData param = IDataFactory.create();
		                    IDataCursor curParam = param.getCursor();
				    curParam.insertAfter("name", nodeName);
		                    IData nodeService = Service.doInvoke("wm.server.ns","getNode",param);
		
				    IDataCursor curNodeService = nodeService.getCursor();
				    String lockStatus = IDataUtil.getString(curNodeService,NSNode.KEY_LOCK_STATUS);
				    Object nodeType = IDataUtil.get(curNodeService,"node");
		
				    if(nodeType instanceof com.wm.app.b2b.server.JavaService && !nodeName.startsWith("QA.QA")) {
		    			int pkgSep = nodeName.indexOf(":");
		    			String javaPackage = nodeName.substring(0,pkgSep);
		 			deleteFullClassName(pkgName, javaPackage);	
					deleteFullSourceName(pkgName, javaPackage);	
					alClasses.add(nodeName);
				    }
				    curNodeService.destroy();
				    curParam.destroy();
				}
			    }
			}
		    }
		
		    int iSize = alClasses.size();
		    for(int i=0; i<iSize; i++) {
			String srv = (String) alClasses.get(i);
			IData param = IDataFactory.create();
		        IDataCursor curParam = param.getCursor();
			curParam.insertAfter("service", srv);
			curParam.destroy();
		        Service.doInvoke("wm.server.ns","buildClass",param);
		    }
		    cursor.destroy();
		} catch(Exception ex) {
		    throw new ServiceException("[Erreur dans RebuildPackage] : " + ex.toString());
		}
		// --- <<IS-END>> ---

                
	}



	public static final void RepairBrokerDocument (IData pipeline)
        throws ServiceException
	{
		// --- <<IS-START(RepairBrokerDocument)>> ---
		// @subtype unknown
		// @sigtype java 3.5
		// [i] field:0:required oldBrokerName
		// [i] field:0:required newBrokerName
		// [i] field:0:required isDocument
		// [i] field:0:required package
		// [i] object:0:optional reload
		try {
		    IDataCursor cursor 		= pipeline.getCursor();
		    String	oldBrokerName  	= IDataUtil.getString(cursor,"oldBrokerName");
		    String	newBrokerName	= IDataUtil.getString(cursor,"newBrokerName");
		    String	isDocument	= IDataUtil.getString(cursor,"isDocument");
		    String	packageName	= IDataUtil.getString(cursor,"package");
		    Boolean	reload		= (Boolean) IDataUtil.get(cursor,"reload");
		    // Recherche du document
		    IData param = IDataFactory.create();
		    IDataCursor curParam = param.getCursor();
		    curParam.insertAfter("name", isDocument);
		    curParam.destroy();
		
		    IData nodeService = Service.doInvoke("wm.server.ns","getNode",param);
		    IDataCursor curNodeService = nodeService.getCursor();
		    Object nodeType = IDataUtil.get(curNodeService,"node");
		    curNodeService.destroy();
		
		    // R\u00e9cup\u00e9ration de l'objet qui mat\u00e9rialise le document
		    NSRecord record = (NSRecord) nodeType;
		    Values valRecord = record.getValues();
		    Values recordInfo = (Values) valRecord.getValue(NSRecord.KEY_NSR_EVENT_DESCRIPTION);
		
		    // Mise \u00e0 jour du broker type
		    recordInfo.setValue(EventDescription.KEY_ED_BROKER_EVENT_TYPE_NAME, newBrokerName);
		
		    // Enregistrement des modifications
		    PackageFS pkgFS = new PackageFS(packageName);
		    Values valOut = new Values() ;
		    valOut.setValue(NSRecord.TYPE_KEY, valRecord);
		    pkgFS.updateDescription(NSName.create(isDocument),valOut);
		
		    // Il faut recharger le package pour prendre en compte les mises \u00e0 jour
		    if( reload != null && reload.booleanValue() ) {
		    	IData paramReload = IDataFactory.create();
		    	IDataCursor curParamReload = paramReload.getCursor();
		    	curParamReload.insertAfter("package",packageName);
		    	curParamReload.destroy();
		    	Service.doInvoke("wm.server.packages","packageReload",paramReload);   
		    }
		    
		    BrokerAdminClient admin = BrokerSynchronizer.current().getAdminClient();
		
		    // V\u00e9rification de la pr\u00e9sence du dicument sur le broker
		    boolean eventDefined = false;
		    try{
		    	admin.getEventAdminTypeDef(oldBrokerName);
		        eventDefined = true;
		    } catch (Exception ex) {}
		    
		    if( eventDefined ) {
		    // Suppression des souscriptions des CGR
		    String[] subscribe = admin.getClientGroupsWhichCanSubscribe(oldBrokerName);
		    for(int i=0; (subscribe != null && i<subscribe.length); i++) {
		        String cgrSubscribeName = subscribe[i];
			ArrayList subList = new ArrayList();
			String[] list = admin.getClientGroupCanSubscribeList(cgrSubscribeName);
			
		        // Le client group 'eventLog' est g\u00e9r\u00e9 automatiquement par le system
		        if( !cgrSubscribeName.equals("eventLog")) {
			    for(int j=0; j<list.length; j++)
				if( !list[j].equalsIgnoreCase(oldBrokerName) )  subList.add(list[j]);
			    subList.add(newBrokerName);
			    String[] newList = new String[subList.size()];
			    admin.setClientGroupCanSubscribeList(cgrSubscribeName, (String[]) subList.toArray(newList));
			}
		    }
		
		    // Suppression des publications des CGR
		    String[] publish = admin.getClientGroupsWhichCanPublish(oldBrokerName);
		    for(int i=0; (publish != null && i<publish.length); i++) {
		        String cgrPublishName = publish[i];
			ArrayList pubList = new ArrayList();
			String[] list = admin.getClientGroupCanPublishList(cgrPublishName);
			for(int j=0; j<list.length; j++)
				if( !list[j].equalsIgnoreCase(oldBrokerName) )  pubList.add(list[j]);
			pubList.add(newBrokerName);
			String[] newList = new String[pubList.size()];
		    	admin.setClientGroupCanPublishList(cgrPublishName, (String[])pubList.toArray(newList));
		    }
		
		    // Suppression du broker de l'ancien document
		    admin.destroyEventType(oldBrokerName, true);
		    }
		
		    cursor.destroy();
		} catch(Exception ex) {
		    throw new ServiceException("[Erreur dans RepairBrokerDocument] : " + ex.toString());
		}
		// --- <<IS-END>> ---

                
	}

	// --- <<IS-START-SHARED>> ---
	public static final String SEP = System.getProperty("file.separator");
	
	public static class ClassFilter implements FileFilter {
	    public String fStart = "";
		public ClassFilter(String fStart) {this.fStart = fStart;}
	
	    public boolean accept(File file) {
			try {
				return file.getCanonicalPath().startsWith(fStart + "$");
			} catch (Exception ex) {
				return false;
			}
		}
	}
	
	//R\u00e9cup\u00e9ration du chemin complet d'une classe d'un package
	private static void deleteFullClassName(String pkgName, String javaPkg) throws java.io.IOException {
	    String javaPackage = javaPkg.replace('.','/');
		File dirConfig = ServerAPI.getPackageConfigDir(pkgName);
	    String fullDirName = dirConfig.getCanonicalPath();
	    File mainClass = new File(fullDirName, ".." + SEP + "code" + SEP + "classes" + SEP + javaPackage + ".class");
		mainClass.delete();
		deleteFullIncludedClassName(mainClass.getCanonicalPath());
	}
	
	//R\u00e9cup\u00e9ration du chemin complet de la source d'une classe d'un package
	private static void deleteFullSourceName(String pkgName, String javaPkg) throws java.io.IOException {
	    String javaPackage = javaPkg.replace('.','/');
		File dirConfig = ServerAPI.getPackageConfigDir(pkgName);
	    String fullDirName = dirConfig.getCanonicalPath();
		new File(fullDirName, ".." + SEP + "code" + SEP + "source" + SEP + javaPackage + ".java").delete();
	}
	
	//R\u00e9cup\u00e9ration des classes publiques d'une classe d'un package
	private static void deleteFullIncludedClassName(String curClass) throws java.io.IOException {
	    String folder = curClass.substring(0, curClass.lastIndexOf(SEP));
	    String fStart = curClass.substring(0, curClass.indexOf(".class") );
		// This filter only returns directories
	    ClassFilter fileFilter = new ClassFilter(fStart);
		File[] files = new File(folder).listFiles(fileFilter);
		if( files != null ) {
			for(int i=0; i<files.length; i++) {
				files[i].delete();
		    }
		}
	}
	// --- <<IS-END-SHARED>> ---
}

