package QA;

// -----( IS Java Code Template v1.2
// -----( CREATED: 2006-06-30 15:44:40 CEST
// -----( ON-HOST: dmd01

import com.wm.data.*;
import com.wm.util.Values;
import com.wm.app.b2b.server.Service;
import com.wm.app.b2b.server.ServiceException;
// --- <<IS-START-IMPORTS>> ---
import java.util.ArrayList;
import com.wm.lang.ns.NSPackage;
import java.util.Enumeration;
import com.wm.lang.ns.NSReference;
import com.wm.lang.ns.NSNode;
import com.wm.lang.ns.NSTrigger;
import com.wm.lang.ns.NSName;
import java.util.Vector;
import com.wm.app.b2b.server.FlowSvcImpl;
import com.wm.app.b2b.ws.ns.NSFacade;
import com.wm.app.b2b.server.ns.Namespace;
import com.wm.lang.flow.FlowElement;
import com.wm.app.b2b.server.InvokeState;
import com.wm.lang.ns.NSRecord;
import com.wm.lang.ns.EventDescription;
import com.wm.app.b2b.util.ServerIf;
import com.wm.app.b2b.server.BaseService;
import com.wm.lang.ns.NSService;
import java.lang.reflect.Method;
// --- <<IS-END-IMPORTS>> ---

public final class QAServices

{
	// ---( internal utility methods )---

	final static QAServices _instance = new QAServices();

	static QAServices _newInstance() { return new QAServices(); }

	static QAServices _cast(Object o) { return (QAServices)o; }

	// ---( server methods )---




	public static final void ListAllDocument (IData pipeline)
        throws ServiceException
	{
		// --- <<IS-START(ListAllDocument)>> ---
		// @subtype unknown
		// @sigtype java 3.5
		// [i] field:0:optional packageName
		try {
		    IDataCursor cursor 			= pipeline.getCursor();
		    String	packageName   		= IDataUtil.getString(cursor,"packageName");
		    NSPackage[] pkg         		= com.wm.app.b2b.server.ns.Namespace.current().getAllPackages();
		
		    for(int i=0; i<pkg.length; i++) {
			String pkgName = pkg[i].getName();
		
		    	if(!pkgName.startsWith("SAP") && !pkgName.startsWith("Wm") && (packageName == null || pkgName.equals(packageName))) {
		     	    Vector list = com.wm.app.b2b.server.ns.Namespace.current().getNodes(new com.wm.app.b2b.server.Package(pkgName));
		      	    Enumeration enum = list.elements();
		      	    while(enum.hasMoreElements()) {
		            	NSNode node = (NSNode)enum.nextElement();
				String nodeName = node.getNSName().getValue();
		   		String typeName = node.getNodeTypeObj().getValue();
		//destroyEventTypes
				if(typeName.equals("record") ) {
		                    IData param = IDataFactory.create();
		                    IDataCursor curParam = param.getCursor();
				    curParam.insertAfter("name", nodeName);
		                    IData nodeService = Service.doInvoke("wm.server.ns","getNode",param);
		
				    IDataCursor curNodeService = nodeService.getCursor();
				    String lockStatus = IDataUtil.getString(curNodeService,"LOCK_STATUS");
				    Object nodeType = IDataUtil.get(curNodeService,"node");
				    curNodeService.destroy();
		
				    if( nodeType instanceof NSRecord) {
					NSRecord record = (NSRecord) nodeType;
					Values recordInfo = (Values) record.getValues().getValue(NSRecord.KEY_NSR_EVENT_DESCRIPTION);
					if( recordInfo != null ) {
					    String brokerEventTypeName = (String) recordInfo.getValue(EventDescription.KEY_ED_BROKER_EVENT_TYPE_NAME);
					    int timeToLive = Integer.parseInt((String) recordInfo.getValue(EventDescription.KEY_ED_TIME_TO_LIVE)); //0
					    String storageType = (String) recordInfo.getValue(EventDescription.KEY_ED_STORAGE_TYPE); //guaranteed
		
					    String isDocName = nodeName.substring(nodeName.lastIndexOf(":") + 1, nodeName.length());
					    String brkDocName = brokerEventTypeName.substring(brokerEventTypeName.lastIndexOf(":") + 1, 
						brokerEventTypeName.length());
					    cursor.insertAfter("package", brkDocName);
		
					}
					//cursor.insertAfter("package", record.getValues().getValue(NSRecord.KEY_NSR_EVENT_DESCRIPTION).getClass().getName());
				    }
					//NSRecord.KEY_NSR_EVENT_DESCRIPTION : eventDescription
					//EventDescription.KEY_ED_BROKER_EVENT_TYPE_NAME : brokerEventTypeName
				    //if( nodeName.indexOf("tableauDeCharge") != -1 ) 
				    //cursor.insertAfter("package", nodeType.getClass().getName());
				}
			    }
			}
		    }
		
		    cursor.destroy();
		} catch(Exception ex) {
		    throw new ServiceException("[Erreur dans ListAllDocument] : " + ex.toString());
		}
		// --- <<IS-END>> ---

                
	}



	public static final void ListAllServices (IData pipeline)
        throws ServiceException
	{
		// --- <<IS-START(ListAllServices)>> ---
		// @subtype unknown
		// @sigtype java 3.5
		// [i] field:0:required packageName
		// [o] record:1:required package
		// [o] - field:0:required name
		// [o] - record:1:required flow
		// [o] -- field:0:required name
		// [o] -- object:0:required LOCK_STATUS
		// [o] - record:1:required java
		// [o] -- field:0:required name
		// [o] -- object:0:required LOCK_STATUS
		// [o] - record:1:required triggers
		// [o] -- field:0:required name
		// [o] -- object:0:required LOCK_STATUS
		// [o] - record:1:required AdapterService
		// [o] -- field:0:required name
		// [o] -- object:0:required LOCK_STATUS
		// [o] - record:1:required documents
		// [o] -- field:0:required name
		// [o] -- object:0:required LOCK_STATUS
		try {
		    IDataCursor cursor 			= pipeline.getCursor();
		    String	packageName   		= IDataUtil.getString(cursor,"packageName");
		    NSPackage[] pkg         		= com.wm.app.b2b.server.ns.Namespace.current().getAllPackages();
		 
		    ArrayList flowSrv = new ArrayList();
		    ArrayList javaSrv = new ArrayList();
		    ArrayList adpSrv = new ArrayList();
		    ArrayList triggers = new ArrayList();
		    ArrayList pkgList = new ArrayList();
		    ArrayList document = new ArrayList();
		
		    for(int i=0; i<pkg.length; i++) {
			String pkgName = pkg[i].getName();
		
		    	if(!pkgName.startsWith("SAP") && !pkgName.startsWith("Wm") && (pkgName.indexOf("Adapter") == -1) && !pkgName.startsWith("QA") && (packageName == null || pkgName.equals(packageName))) {
		     	    Vector list = com.wm.app.b2b.server.ns.Namespace.current().getNodes(new com.wm.app.b2b.server.Package(pkgName));
		      	    Enumeration enum = list.elements();
		      	    while(enum.hasMoreElements()) {
		            	NSNode node = (NSNode)enum.nextElement();
				String nodeName = node.getNSName().getValue();
		   		String typeName = node.getNodeTypeObj().getValue();
		
		            	if(typeName.equals(ServerIf.KEY_SERVICE_NAME) || typeName.equals(NSTrigger.TYPE_KEY) || 
					typeName.equals(ServerIf.NSTYPE_ADAPTER_SERVICE) || typeName.equals(NSRecord.TYPE_KEY)) {
		
		                    IData param = IDataFactory.create();
		                    IDataCursor curParam = param.getCursor();
				    curParam.insertAfter("name", nodeName);
		                    IData nodeService = Service.doInvoke("wm.server.ns","getNode",param);
		
				    IDataCursor curNodeService = nodeService.getCursor();
				    String lockStatus = IDataUtil.getString(curNodeService,NSNode.KEY_LOCK_STATUS);
				    Object nodeType = IDataUtil.get(curNodeService,"node");
		
				    if(nodeType.getClass().getName().equals("com.wm.pkg.art.ns.AdapterServiceNode") && !nodeName.startsWith("QA.QA")) {
			            	IData out = IDataFactory.create();
		                    	IDataCursor curOut = out.getCursor();
				    	curOut.insertAfter("name", nodeName);
				    	curOut.insertAfter("LOCK_STATUS", new Integer(lockStatus));
				    	adpSrv.add(out);
					curOut.destroy();			
				    }
		
				    if(nodeType instanceof com.wm.app.b2b.server.FlowSvcImpl && !nodeName.startsWith("QA.QA")) {
			            	IData out = IDataFactory.create();
		                    	IDataCursor curOut = out.getCursor();
				    	curOut.insertAfter("name", nodeName);
				    	curOut.insertAfter("LOCK_STATUS", new Integer(lockStatus));
				    	flowSrv.add(out);
					curOut.destroy();
				    }
		
				    if(nodeType instanceof com.wm.app.b2b.server.JavaService && !nodeName.startsWith("QA.QA")) {
			            	IData out = IDataFactory.create();
		                    	IDataCursor curOut = out.getCursor();
				    	curOut.insertAfter("name", nodeName);
				    	curOut.insertAfter("LOCK_STATUS", new Integer(lockStatus));
				    	javaSrv.add(out);
					curOut.destroy();
				    }
		
				    if(nodeType instanceof com.wm.app.b2b.server.dispatcher.trigger.Trigger && !nodeName.startsWith("QA.QA")) {
			            	IData out = IDataFactory.create();
		                    	IDataCursor curOut = out.getCursor();
				    	curOut.insertAfter("name", nodeName);
				    	curOut.insertAfter("LOCK_STATUS", new Integer(lockStatus));
				    	triggers.add(out);
					curOut.destroy();
				    }
		
		
		
				    if(nodeType instanceof com.wm.lang.ns.NSRecord && !nodeName.startsWith("QA.QA")) {
					NSRecord record = (NSRecord) nodeType;
					Values recordInfo = (Values) record.getValues().getValue(NSRecord.KEY_NSR_EVENT_DESCRIPTION);
		
					// Seuls les documents publiables sur le broker sont utilis\u00e9s
					if( recordInfo != null ) {
			            	    IData out = IDataFactory.create();
			            	    IDataCursor curOut = out.getCursor();
			            	    curOut.insertAfter("name", nodeName);
			            	    curOut.insertAfter("LOCK_STATUS", new Integer(lockStatus));
			            	    document.add(out);
			            	    curOut.destroy();
					}
				    }
				    curNodeService.destroy();
				    curParam.destroy();
		            	}
		      	    }
			    IData outPkg = IDataFactory.create();
		            IDataCursor curPkg = outPkg.getCursor();
		
			    curPkg.insertAfter("name", pkgName);
			    int iFlowSize = flowSrv.size();
			    if(iFlowSize != 0 ) {
			    	IData[] flows = new IData[iFlowSize];
			    	curPkg.insertAfter("flow", (IData[]) flowSrv.toArray(flows));
			    	flowSrv = new ArrayList();
			    }
		
			    int iJavaSize = javaSrv.size();
			    if(iJavaSize != 0 ) {
			    	IData[] javas = new IData[iJavaSize];
			    	curPkg.insertAfter("java", (IData[]) javaSrv.toArray(javas));
			    	javaSrv = new ArrayList();
			    }
		
			    int iAdpSize = adpSrv.size();
			    if(iAdpSize != 0 ) {
			    	IData[] adps = new IData[iAdpSize];
			    	curPkg.insertAfter("AdapterService", (IData[]) adpSrv.toArray(adps));
			    	adpSrv = new ArrayList();
			    }
		
			    int iTriggerSize = triggers.size();
			    if(iTriggerSize != 0 ) {
			    	IData[] itriggers = new IData[iTriggerSize];
			    	curPkg.insertAfter("triggers", (IData[]) triggers.toArray(itriggers));
			    	triggers = new ArrayList();
			    }
		
			    int iDocumentSize = document.size();
			    if(iDocumentSize != 0 ) {
			    	IData[] idocs = new IData[iDocumentSize];
			    	curPkg.insertAfter("documents", (IData[]) document.toArray(idocs));
			    	document = new ArrayList();
			    }
			    curPkg.destroy();
		            if(iJavaSize!=0 || iFlowSize!=0 || iTriggerSize!=0 || iAdpSize!=0 || iDocumentSize!=0) pkgList.add(outPkg);
		    	}
		    }
		
		    int iPackage = pkgList.size();
		    IData[] packages = new IData[iPackage];
		    cursor.insertAfter("package", (IData[]) pkgList.toArray(packages));
		    cursor.destroy();
		} catch(Exception ex) {
		    throw new ServiceException("[Erreur dans ListAllServices] : " + ex.toString());
		}
		// --- <<IS-END>> ---

                
	}



	public static final void ListPackageDependency (IData pipeline)
        throws ServiceException
	{
		// --- <<IS-START(ListPackageDependency)>> ---
		// @subtype unknown
		// @sigtype java 3.5
		// [i] field:0:required packageName
		// [o] field:1:optional successors
		// [o] field:1:optional not_found
		try {
		    IDataCursor cursor 			= pipeline.getCursor();
		    String	packageName   		= IDataUtil.getString(cursor,"packageName");
		    ArrayList packageDep = new ArrayList();
		    ArrayList packageErrors = new ArrayList();
			
		    	if(!packageName.startsWith("SAP") && !packageName.startsWith("Wm") && !packageName.startsWith("QA") ) {
		     	    Vector list = com.wm.app.b2b.server.ns.Namespace.current().getNodes(new com.wm.app.b2b.server.Package(packageName));
		      	    Enumeration enum = list.elements();
		      	    while(enum.hasMoreElements()) {
		            	NSNode node = (NSNode)enum.nextElement();
				String nodeName = node.getNSName().getValue();
		   		String typeName = node.getNodeTypeObj().getValue();
		
				// Les d\u00e9pendances se font sur les services (java, flow et adapter) et sur les documents des triggers
		            	if(typeName.equals(ServerIf.KEY_SERVICE_NAME) || typeName.equals(NSTrigger.TYPE_KEY) || 
					typeName.equals(ServerIf.NSTYPE_ADAPTER_SERVICE)) {
		
		                    IData param = IDataFactory.create();
		                    IDataCursor curParam = param.getCursor();
				    curParam.insertAfter("name", nodeName);
				    curParam.destroy();
		
		                    IData nodeService = Service.doInvoke("wm.server.ns","getNode",param);
				    IDataCursor curNodeService = nodeService.getCursor();
				    Object nodeType = IDataUtil.get(curNodeService,"node");
				    curNodeService.destroy();
		
				    // Pour les adp services, il faut verifier une \u00e9ventuelle d\u00e9pendance au niveau de la connection
				    if(nodeType.getClass().getName().equals("com.wm.pkg.art.ns.AdapterServiceNode" ) 
					&& !nodeName.startsWith("QA.QA")) {
		
					Method  mthConnectionName = nodeType.getClass().getDeclaredMethod("getConnectionName",null);
					String adpConnectionName = (String) mthConnectionName.invoke(nodeType,null);
		
					// Recherche de la pr\u00e9sence de la connexion
		                        IData paramAdpCon = IDataFactory.create();
		                        IDataCursor curParamAdpCon = paramAdpCon.getCursor();
		                        curParamAdpCon.insertAfter("name", adpConnectionName);
		                        curParamAdpCon.destroy();
		
		                        IData nodeServiceAdpCon = Service.doInvoke("wm.server.ns","getNode",paramAdpCon);
		                        IDataCursor curNodeServiceAdpCon = nodeServiceAdpCon.getCursor();
		                        Object nodeTypeConAdp = IDataUtil.get(curNodeServiceAdpCon,"node");
		                        curNodeServiceAdpCon.destroy();
		
					// null si pas de connexion
					if( nodeTypeConAdp == null ) {
					    String errorName = "connection : " + adpConnectionName + " doesn't exist";
					    if( !packageErrors.contains(errorName)) packageErrors.add(errorName);
					} else {     
					    Method  mthAdapterTypeName = nodeType.getClass().getDeclaredMethod("getAdapterTypeName",null);
					    String adpTypeName = (String)mthAdapterTypeName.invoke(nodeType,null);
					    try {
					    	Method  mthAdapterType = nodeType.getClass().getDeclaredMethod("getAdapterType",null);
					    	mthAdapterType.setAccessible(true);
					    	Object adpType = mthAdapterType.invoke(nodeType,null);
					
					    	Method  mthAdapterPackageName = adpType.getClass().getDeclaredMethod("getAdapterPackageName",null);
					    	String adpPkgName = (String) mthAdapterPackageName.invoke(adpType,null);
		
					    	// Ajout du package de l'adapter
					    	if( !packageName.equals(adpPkgName) && !packageDep.contains(adpPkgName)) packageDep.add(adpPkgName);
					    } catch (Exception ex) {
					    	String errorName = "no adapter package for : " + adpTypeName + " " + adpConnectionName;
					    	if( !packageErrors.contains(errorName)) packageErrors.add(errorName);
					    }
					}
		
					// Nom du package de la connexion adapteur
					String adpConPkgName = getPackageForNodeName(adpConnectionName);
					if( adpConPkgName != null ) {
					    if( !packageName.equals(adpConPkgName) && !packageDep.contains(adpConPkgName)) packageDep.add(adpConPkgName);
					} else {
					    String errorName = "no adapter connection for : " + nodeName;
					    if( !packageErrors.contains(errorName)) packageErrors.add(errorName);
					}
				    }
		
				    // Pour les flow services, la d\u00e9pendance est au niveau du contenu
				    if( nodeType instanceof com.wm.app.b2b.server.FlowSvcImpl && !nodeName.startsWith("QA.QA")) {
				    	Values v = NSFacade.valuesEncodeFlowSvcImpl((FlowSvcImpl) nodeType);
		    			Vector vect = (Vector) ((Values) v.get(ServerIf.DM_KEY_FLOW)).get(ServerIf.KEY_NODES); //flow, nodes
		
		    			for(int iflow=0; (vect != null && iflow<vect.size()); iflow++) {
		    			    listFlowElement(packageName, "/", (FlowElement) vect.get(iflow), packageDep, packageErrors);
					}
				    }
		
				    // Pour les triggers, la d\u00e9pendance est au niveau des documents / service
				    if(nodeType instanceof com.wm.app.b2b.server.dispatcher.trigger.Trigger && !nodeName.startsWith("QA.QA")) {
					NSReference[] ref = ((NSTrigger) nodeType).getDependencies();
					for(int iref=0; (ref != null && iref<ref.length); iref++) {
					    NSReference curRef = ref[iref];
					    String refName = curRef.getReference().getFullName();
					    String trgPkgName = getPackageForNodeName(refName);
		
					    if( trgPkgName != null ) {
						if( !packageName.equals(trgPkgName) && !packageDep.contains(trgPkgName)) packageDep.add(trgPkgName);
					    } else {
						String errorName = "element not found : " + refName;
						if( !packageErrors.contains(errorName)) packageErrors.add(errorName);
					    }
					}
				    }
				}
			    }
			}
		    
		
		    if( packageDep.size() > 0 ) {
		 	String[] depArray = new String[packageDep.size()];
			cursor.insertAfter("successors", (String[]) packageDep.toArray(depArray));	
		    }
		    if( packageErrors.size() > 0 ) {
		 	String[] depArray = new String[packageErrors.size()];
			cursor.insertAfter("not_found", (String[]) packageErrors.toArray(depArray));	
		    }
		    cursor.destroy();
		} catch(Exception ex) {
		    throw new ServiceException("[Erreur dans ListAllServices] : " + ex.toString());
		}
		// --- <<IS-END>> ---

                
	}



	public static final void TransformText (IData pipeline)
        throws ServiceException
	{
		// --- <<IS-START(TransformText)>> ---
		// @subtype unknown
		// @sigtype java 3.5
		// [i] record:1:required input
		// [i] field:0:required out
		try {       
		  IDataCursor 	pipelineCursor 	= pipeline.getCursor();       
		  IData[]     	content		= IDataUtil.getIDataArray(pipelineCursor,"input");
		  String	outtxt		= IDataUtil.getString(pipelineCursor,"out");
		
		  
		  StringBuffer header = new StringBuffer(2048); 
		  StringBuffer out = new StringBuffer(2048);
		
		  boolean addHeader = true;
		  for(int i=0; content!=null && i<content.length; i++) {
		    IData current 	= content[i];   
		    StringBuffer tmp = new StringBuffer(2048);  
		    browseIData(content[i], tmp, out, header, addHeader);
		    addHeader =false;
		  }     
		
		   pipelineCursor.insertAfter(outtxt, header.toString() + "\n" + out.toString());
		   pipelineCursor.destroy();    
		   //System.out.println(header.toString());
		   //System.out.println(out.toString());
		} catch (Exception e) {       
		  throw new ServiceException(e.getMessage());       
		}   
		// --- <<IS-END>> ---

                
	}

	// --- <<IS-START-SHARED>> ---
	private static final void browseIData(IData content, StringBuffer tmp, StringBuffer out, StringBuffer header, boolean addHeader) {
		IDataCursor cursor	= content.getCursor(); 
	    StringBuffer local = new StringBuffer(2048);
		local.append( tmp.toString() );
	    boolean recurse = false;
	
		while(cursor.next()) {
	      String key = cursor.getKey();
	      Object val = cursor.getValue();
		  if( val instanceof String ) {
			if( addHeader ) header.append(key + ";");
	        local.append( (String)val );
			local.append(";");
		  }
		  if( val instanceof String[] ) {
			String[] iVal = (String[]) val;
			if( addHeader ) header.append(key + ";");
			for(int i=0; i<iVal.length; i++) {
				out.append( local.toString() );
				out.append( iVal[i] );
				out.append("\n");
			}
			recurse = true;
		  }
	      if( val instanceof IData ) {
			browseIData((IData) val, local, out, header, addHeader);
			addHeader = false;
		    recurse = true;
		  }
		  if( val instanceof IData[] ) {
			IData[] iVal = (IData[]) val;
			for(int i=0; i<iVal.length; i++) {
				browseIData(iVal[i], local, out, header, addHeader);
				addHeader = false;
			}
		    recurse = true;
		  }
	    }
		if( !recurse ) {
			out.append( local.toString() );
			out.append("\n");
		}
		cursor.destroy();    
	}
	
	
	private static final void listFlowElement(String packageName, String path, FlowElement fe, 
		ArrayList packageDep, ArrayList packageErrors) throws Exception {
	
		int nbItem = fe.getNodeCount();
		Values val = fe.getValues();
		String name = (String) val.get(NSService.TYPE_KEY); //service
	    String disabled = (String) val.get(FlowElement.KEY_ELEMENT_DISABLED); //disabled
	
	
		// Test de d\u00e9pendance pour les services
		if( name != null && disabled == null) {
	    	String nodePkgName = getPackageForNodeName(name);
	
			if( nodePkgName != null ) {
				if( !packageName.equals(nodePkgName) && !packageDep.contains(nodePkgName)) packageDep.add(nodePkgName);
			} else {
			    String errorName = "element not found : " + name;
				if( !packageErrors.contains(errorName)) packageErrors.add(errorName);
			}
		}
	
	    for(int i=0; i<nbItem; i++) {
			listFlowElement(packageName, path + fe.getFlowType() + "/", fe.getNodeAt(i), packageDep, packageErrors);
		}
	}
	
	
	// Nom du package pour un \u00e9l\u00e9ment Node
	private static String getPackageForNodeName(String nodeName) throws Exception {
	  	IData param = IDataFactory.create();
	  	IDataCursor curParam = param.getCursor();
	  	curParam.insertAfter("name", nodeName);
	  	curParam.destroy();
	  
	  	IData nodeService = Service.doInvoke("wm.server.ns","getNode",param);
	  	IDataCursor curNodeService = nodeService.getCursor();
	  	NSNode nodeType = (NSNode) IDataUtil.get(curNodeService,"node");
	  	curNodeService.destroy();
	  
	  	if( nodeType != null ) {
	  		return nodeType.getPackage().getName();
	  	} else {
	    	return null;
	  	}	 
	}
	// --- <<IS-END-SHARED>> ---
}

